package cn.com.ctop.toutiao.modules.report.service.impl;

import cn.com.ctop.common.module.utils.ResultMapUtils;
import cn.com.ctop.common.module.utils.StatusCode;
import cn.com.ctop.toutiao.modules.material.vo.BytedanceVideoVo;
import cn.com.ctop.toutiao.modules.report.DTO.ImageCostVO;
import cn.com.ctop.toutiao.modules.report.entity.BytedanceReportMaterialDaily;
import cn.com.ctop.toutiao.modules.report.mapper.BytedanceReportMaterialDailyMapper;
import cn.com.ctop.toutiao.modules.report.service.IBytedanceReportMaterialDailyService;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 素材报表
 * @author jeecg-boot
 * @date   2020-04-16
 * @version V1.0
 */
@Service
@Primary

public class BytedanceReportMaterialDailyServiceImpl extends ServiceImpl<BytedanceReportMaterialDailyMapper, BytedanceReportMaterialDaily> implements IBytedanceReportMaterialDailyService {
    @Autowired
    private BytedanceReportMaterialDailyMapper bytedanceReportMaterialDailyMapper;
    @Override
    public List<BytedanceReportMaterialDaily> getListByParams(String date) {
        QueryWrapper<BytedanceReportMaterialDaily>queryWrapper = new QueryWrapper<>();
        if(null != date&&!date.trim().equals("")){
            queryWrapper.eq("stat_datetime",date);
        }
        queryWrapper.orderByAsc("stat_datetime");
        return this.list(queryWrapper);
    }

    @Override
    public List<BytedanceVideoVo> getVideoVoByDate(String date) {
        return bytedanceReportMaterialDailyMapper.getVideoVoByDate(date);
    }

    @Override
    public Map<String,Object> bytedanceImageCost(JSONObject data) {
        Map<String,Object>result = new HashMap<>();
        String startDate = data.getString("startDate");
        if(null == startDate||startDate.trim().equals("")){
            startDate = null;
        }
        String endDate = data.getString("endDate");
        if(null == endDate||endDate.trim().equals("")){
            endDate = null;
        }
        JSONArray accountList = data.getJSONArray("accountList");
        if(null==accountList||accountList.isEmpty()){
            accountList = null;
        }
        String code = data.getString("code");
        if(null == code||code.trim().equals("")){
            code = null;
        }
        Integer pageSize = data.getInteger("pageSize");
        Integer pageNumber = data.getInteger("pageNumber");
        if(null == pageNumber||pageNumber ==0){
            pageNumber = 1;
        }
        if(null == pageSize||pageSize ==0){
            pageSize = 10;
        }
        PageHelper.startPage(pageNumber,pageSize);
        List<ImageCostVO>vos = bytedanceReportMaterialDailyMapper.bytedanceImageCost(startDate,endDate,accountList,code,(pageNumber-1)*pageSize,pageSize);
        PageInfo<ImageCostVO> pageInfo = new PageInfo<>(vos);
        result.put("data",pageInfo);
        ResultMapUtils.setResultMap(result, StatusCode.COMMON_SUCCESS);
        return result;

    }


}
